#include "testlib.h"
#include <iostream>
#include <cassert>

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define len(a) (static_cast<int>(a.size()))

using namespace std;

int main(int argc, char** argv) {
    registerGen(argc, argv, 0);
    int n = atoi(argv[1]);
    int c = atoi(argv[2]);
    vector<int> use;
    for (int i = 3; i < argc; i++) {
        use.pb(atoi(argv[i]));
    }
    vector<int> all_;
    for (int i = 0; i < (1 << len(use)); i++) {
        int cur = 0;
        for (int j = 0; j < len(use); j++) {
            if (i & (1 << j)) {
                cur += use[j];
            }
        }
        if (abs(cur) <= c) {
            all_.pb(cur);
        }
    }
    sort(all(all_)), all_.resize(unique(all(all_)) - all_.begin());
    shuffle(all_.begin(), all_.end());
    assert(len(all_) >= n);
    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << all_[i] << " \n"[i + 1 == n];
    }
    return 0;
}
