#include <iostream>
#include <fstream>
#include <sstream>

#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <deque>
#include <string>

#include <algorithm>
#include <numeric>

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cmath>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(a) ((int) (a).size())

#ifdef CUTEBMAING
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = (1 << 30) - 1;
const int64 linf = (1ll << 62) - 1;
const int N = 1e6 + 100;

int n;
int a[N];

int main() {
  cin >> n;
  for (int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
  }
  int mx = -inf;
  for (int i = 0; i < n; i++) {
    mx = max(mx, abs(a[i]));
  }
  int q = 0;
  while ((1 << q) < mx * 2) {
    q++;
  }
  tuple<int, int, int> ans = { inf, 0, 0 };
  for (int i = 0; i < (1 << q); i++) {
    vector<int> x = { 0 }, nx;
    for (int j = 0; j < n; j++) {
      int s = i;
      for (int s = i;; s = (s - 1) & i) {
        int cur = a[j];
        for (int z = 0; z < q; z++) {
          cur += s & (1 << z);
        }
        if (cur >= 0) {
          for (int l : x) {
            nx.pb(l | cur);
          }
        }
        if (s == 0) {
          break;
        }
      }
      swap(x, nx);
      nx.clear();
      sort(all(x)), x.resize(unique(all(x)) - x.begin());
    }
    int popcount1 = __builtin_popcount(i);
    for (int j : x) {
      int result = popcount1 + __builtin_popcount(j);
      if (result < get<0>(ans)) {
        ans = make_tuple(result, i, j);
      }
    }
  }
  int result, i1, i2; tie(result, i1, i2) = ans;
  vector<int> cert;
  for (int i = 0; i < q; i++) {
    if (i1 & (1 << i)) {
      cert.pb(-(1 << i));
    }
    if (i2 & (1 << i)) {
      cert.pb(1 << i);
    }
  }
  assert(result == len(cert));
  cout << result << endl;
  for (int i = 0; i < len(cert); i++) {
    printf("%d%c", cert[i], " \n"[i + 1 == len(cert)]);
  }
  return 0;
}
