#include <iostream>
#include <fstream>
#include <sstream>

#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <deque>
#include <string>

#include <algorithm>
#include <numeric>

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cmath>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(a) ((int) (a).size())

#ifdef CUTEBMAING
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = (1 << 30) - 1;
const int64 linf = (1ll << 62) - 1;

int n, a;

int main() {
  cin >> n;
  assert(n == 1);
  cin >> a;
  int mult = 1;
  if (a < 0) {
    mult = -1;
    a = -a;
  }
  int size = max(1, 2 * a);
  vector<int> dp(size, inf), parent(size, -1);
  dp[0] = 0;
  for (int i = 1; i < size; i <<= 1) {
    for (int j = 0; j < size - i; j++) {
      if (dp[i + j] > dp[j] + 1) {
        dp[i + j] = dp[j] + 1;
        parent[i + j] = i;
      }
    }
  }
  for (int i = 1; i < size; i <<= 1) {
    for (int j = size - 1; j >= i; j--) {
      if (dp[j - i] > dp[j] + 1) {
        dp[j - i] = dp[j] + 1;
        parent[j - i] = -i;
      }
    }
  }
  cout << dp[a] << endl;
  for (int i = a; i != 0; i -= parent[i]) {
    cout << mult * parent[i] << " ";
  }
  puts("");
  return 0;
}
