#include <cstdio>
#include <tuple>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> A;
vector<char> can;

bool check(int q, int mskp, int mskn) {
    int off = 1 << q;
    can.assign(2 * off + 1, 0);
    can[off] = 1;
    for (int i = 0; i < q; i++) {
        int pw = 1 << i;
        if ((mskn >> i) & 1) {
            for (int j = 0; j + pw <= 2 * off; j++) {
                can[j] |= can[j + pw];
            }
        }
        if ((mskp >> i) & 1) {
            for (int j = 2 * off; j >= pw; j--) {
                can[j] |= can[j - pw];
            }
        }
    }
    for (int a : A) {
        if (!can[off + a]) {
            return false;
        }
    }
    return true;
}

int main() {
    int n;
    scanf("%d", &n);
    A.resize(n);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        scanf("%d", &A[i]);
        mx = max(mx, abs(A[i]));
    }

    int q = 0;
    while ((1 << q) < mx) { // may be a mistake
        ++q;
    }
    ++q;

    tuple<int, int, int> ans(10000, 0, 0);

    for (int mskp = 0; mskp < (1 << q); ++mskp) {
        for (int mskn = 0; mskn < (1 << q); ++mskn) {
            if (check(q, mskp, mskn)) {
                ans = min(ans, make_tuple(__builtin_popcount(mskp) + __builtin_popcount(mskn), mskp, mskn));
            }
        }
    }
    printf("%d\n", get<0>(ans));
    for (int i = 0; i < q; i++) {
        if ((get<1>(ans) >> i) & 1) {
            printf("%d ", 1 << i);
        }
        if ((get<2>(ans) >> i) & 1) {
            printf("%d ", -(1 << i));
        }
    }
    printf("\n");
}
