#include <iostream>
#include <fstream>
#include <sstream>

#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <deque>
#include <string>

#include <algorithm>
#include <numeric>

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cmath>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(a) ((int) (a).size())

#ifdef CUTEBMAING
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = (1 << 30) - 1;
const int64 linf = (1ll << 62) - 1;

vector<int> ans;

int bestAns = inf;
vector<int> cert;

void run(vector<int>&& a, int x, int q, int cur = 0) {
  sort(all(a)), a.resize(unique(all(a)) - a.begin());
  if (x >= q) {
    if (len(a) == 1 && a.front() == 0) {
      if (bestAns > cur) {
        bestAns = cur;
        cert = ans;
      }
      return ;
    }
  }
  bool need = false;
  for (int i : a) {
    if (abs(i) & (1 << x)) {
      need = true;
      break;
    }
  }
  if (!need) {
    run(std::move(a), x + 1, q, cur);
  } else {
    vector<int> na;
    for (int& i : a) {
      if (abs(i) & (1 << x)) {
        na.pb(i + (1 << x));
      } else {
        na.pb(i);
      }
    }
    ans.pb(-(1 << x));
    run(std::move(na), x + 1, q, cur + 1);
    ans.pbk();
    na.clear();
    for (int& i : a) {
      if (abs(i) & (1 << x)) {
        na.pb(i - (1 << x));
      } else {
        na.pb(i);
      }
    }
    ans.pb(1 << x);
    run(std::move(na), x + 1, q, cur + 1);
    ans.pbk();
  }
}

int main() {
  int n; scanf("%d", &n);
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
  }
  int mx = -inf;
  for (int i : a) {
    mx = max(mx, abs(i));
  }
  int q = 1;
  while ((1 << q) <= mx * 2) {
    q++;
  }
  run(std::move(a), 0, q);
  cout << bestAns << endl;
  for (int i = 0; i < bestAns; i++) {
    printf("%d%c", cert[i], " \n"[i + 1 == bestAns]);
  }
  return 0;
}
